unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons, xmldom, XMLIntf, msxmldom, XMLDoc, shellapi;

type
  TformMenuPrincipal = class(TForm)
    GroupBox1: TGroupBox;
    bSel: TBitBtn;
    txtXSD: TEdit;
    arXSD: TTreeView;
    btArbol: TBitBtn;
    dlAbrir: TOpenDialog;
    LWEB: TLabel;
    procedure btArbolClick(Sender: TObject);
    procedure obtenerArbolXSD (nodoXML : IXMLNode; nodoArbol : TTreeNode);
    procedure bSelClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

procedure TformMenuPrincipal.obtenerArbolXSD (nodoXML : IXMLNode; nodoArbol : TTreeNode);
var
  I: Integer;
  nuevoNodoArbol : TTreeNode;
  nodoTexto : string;
  atributoNodo : IXMLNode;
begin
  // No tener en cuenta nodos de texto y especiales
  if nodoXML.NodeType = ntElement then
  begin
    //Aadir el propio nodo
    nodoTexto := nodoXML.NodeName;
    if nodoXML.IsTextElement then
      nodoTexto := nodoTexto + ' = ' + nodoXML.NodeValue;
    nuevoNodoArbol := arXSD.Items.AddChild(nodoArbol, nodoTexto);

    //Aadir atributos
    for I := 0 to nodoXML.AttributeNodes.Count - 1 do
    begin
      atributoNodo := nodoXML.AttributeNodes.Nodes[I];
      arXSD.Items.AddChild(nuevoNodoArbol,
          '[' + atributoNodo.NodeName + ' = "' + atributoNodo.Text + '"]');
    end;

    // Aade cada nodo secundario (hijo)
    if nodoXML.HasChildNodes then
      for I := 0 to nodoXML.ChildNodes.Count - 1 do
        obtenerArbolXSD (nodoXML.ChildNodes.Nodes [I], nuevoNodoArbol);
  end;
end;

procedure TformMenuPrincipal.btArbolClick(Sender: TObject);
var
  xmlDoc : TXMLDocument;
begin
  if FileExists(txtXSD.Text) then
  begin
    arXSD.Visible := false;
    arXSD.Items.Clear;
    xmlDoc := TXMLDocument.Create(Self);
    xmlDoc.LoadFromFile(dlAbrir.FileName);
    obtenerArbolXSD (xmlDoc.DocumentElement, nil);
    arXSD.FullExpand;
    arXSD.Visible := true;    
  end
  else
    MessageDlg('El fichero XSD seleccionado no existe.', mtInformation, [mbok], 0);
end;

procedure TformMenuPrincipal.bSelClick(Sender: TObject);
begin
  dlAbrir.InitialDir := ExtractFilePath (Application.ExeName);
  if dlAbrir.Execute then
    txtXSD.Text := dlAbrir.FileName;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
